﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;
using Microsoft.Deployment.WindowsInstaller;
using Microsoft.Deployment.WindowsInstaller.Linq;


namespace Get_files_path_from_same_component
{
    public class CustomActions
    {
        [CustomAction]
        public static ActionResult GetFilesPath(Session session)
        {
            try
            {
                session.Log("Begin GetFilesPath custom action");

                // get folder path through its property
                string folderPath = session["aFolder_Dir"];

                List <string> filesPathList = new List<string> ();
                // new QDatabase(@"D:\Danut Projects\How to get list of file paths to the installed files in a custom dll\SampleApp-SetupFiles\SampleApp.msi", DatabaseOpenMode.ReadOnly)
                session.Log("Database open");
                using (var database = session.Database)
                {
                    session.Log("Database openned");
                    using (var view = database.OpenView(database.Tables["File"].SqlSelectString))
                    {
                        session.Log("File table openned");
                        view.Execute();
                        
                        //Get the files from table that are part of ||||OtherFileCopy2.txt||| component
                        foreach (var rec in view) 
                        {
                            if (rec.GetString("Component_") == "OtherFileCopy2.txt")
                            {
                                filesPathList.Add(folderPath + rec.GetString("File"));
                            }
                        }
                        // List files in the log
                        session.Log("The files that are assigned under the *OtherFileCopy2* component are:");
                        foreach (var test in filesPathList)
                        {
                               session.Log(test.ToString());
                        }
                    }
                }
                session.Log("End GetFilesPath custom action");
            }
            catch(Exception ex)
            {
                session.Log("Error on GetFilesPath: {0}", ex.ToString());
                return ActionResult.Failure;
            }
           
            return ActionResult.Success;
        }
    }
}
